diff --git a/configure.ac b/configure.ac
index c867af3..4ff5311 100644
--- a/configure.ac
+++ b/configure.ac
@@ -416,6 +416,8 @@ fi
 AM_CONDITIONAL(HAVE_LIBCPUFREQ, test x$have_libcpufreq = xyes)
 AC_SUBST(LIBCPUFREQ_LIBS)
 
+AC_CHECK_HEADERS([cpupower.h])
+
 build_cpufreq_applet=no
 
 if test x$disable_cpufreq = xno; then
diff --git a/cpufreq/src/cpufreq-monitor-libcpufreq.c b/cpufreq/src/cpufreq-monitor-libcpufreq.c
index 40c44ba..120693c 100644
--- a/cpufreq/src/cpufreq-monitor-libcpufreq.c
+++ b/cpufreq/src/cpufreq-monitor-libcpufreq.c
@@ -19,11 +19,16 @@
  * Authors : Carlos Garca Campos <carlosgc@gnome.org>
  */
 
+#include <config.h>
+
 #include <glib.h>
 #include <glib/gi18n.h>
 
 #include <stdlib.h>
 #include <cpufreq.h>
+#ifdef HAVE_CPUPOWER_H
+#include <cpupower.h>
+#endif
 
 #include "cpufreq-monitor-libcpufreq.h"
 #include "cpufreq-utils.h"
@@ -111,7 +114,11 @@ cpufreq_monitor_libcpufreq_run (CPUFreqMonitor *monitor)
 		/* Check whether it failed because
 		 * cpu is not online.
 		 */
+#ifndef HAVE_CPUPOWER_H
 		if (!cpufreq_cpu_exists (cpu)) {
+#else
+    if (cpupower_is_cpu_online (cpu)) {
+#endif
 			g_object_set (G_OBJECT (monitor), "online", FALSE, NULL);
 			return TRUE;
 		}
